
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

EEP_HW_set_WR:
; Save Register
		Push	temp
		Push	temp2
		Push	temp3
		Push	temp4
		Push	Low_Byte
		Push	High_Byte
		Push	XL
		Push	XH
		Push	ZL
		Push	ZH

;		lds		temp4, SREG_2_SRAM						// temp3= temporre SRAM_2
;		cbr		temp4, 1<<SHWS
;		sbrs	temp4, SEWRE							// Save EEPROM Data Write Enable
; If SEWRE = 0
;		rjmp	EHSW_SEWRE0								// Register Daten wiederherstellen
; If SEWRE = 1	
		ldi		Low_Byte, Low (Control_Reg_EEP)			// EEPROM- Pointer Low_Byte| Ab hier wird beschrieben
		ldi		High_Byte, High (Control_Reg_EEP)		// EEPROM- Pointer High_Byte| Ab hier wird beschrieben
		ldi		ZL, Low (PWM_vs_CALC_EEP+1)				// Bis hier wird geschrieben
		ldi		ZH, High (PWM_vs_CALC_EEP+1)			// Bis hier wird geschrieben
		ldi		XL, Low (Control_Reg_SRAM)				// Bis hier wird geschrieben
		ldi		XH, High (Control_Reg_SRAM)			    // Bis hier wird geschrieben
EEP_HW_set_WR_loop:
		WDR												// WATCHDOG Reset
		clr		temp3									// 	
		ld		temp, X+ 
EEP_Rewrite_HW_Data:
		cpi		temp3, 3								// Schreibversuche
		Breq	EEP_HW_set_WR_ERR						// Schreiben nicht mglich	
		rcall	EEPROM_write
		mov		temp2, temp								// Zu schreibende Daten absichern
		rcall	EEPROM_read								// Geschriebebe Daten auslesen
		inc		temp3									// Schreibversuchszhler erhhen (+1)
		cp		temp, temp2								// berprfe ob die geschriebene und ausgelesene Daten bereinstimmen
		Brne	EEP_Rewrite_HW_Data
		adiw	Low_Byte, 1
		cp		Low_Byte, ZL
		cpc		High_Byte, ZH
		Brne	EEP_HW_set_WR_loop
EHSW_SEWRE0:	
;		sts		SREG_2_SRAM, temp4						// vernderungen abspeichern
; Recover Register
		Pop		ZH
		Pop		ZL
		Pop		XH
		Pop		XL
		Pop		High_Byte
		Pop		Low_Byte
		Pop		temp4
		Pop		temp3
		Pop		temp2
		Pop		temp
 	ret

EEP_HW_set_WR_ERR:						
;		sbr		temp4, 1<<EWRER						// EEPWE: EEPROM Write ERROR
;		sts		SREG_2_SRAM, temp4						// vernderungen abspeichern
; Recover Register
		Pop		ZH
		Pop		ZL
		Pop		XH
		Pop		XL
		Pop		High_Byte
		Pop		Low_Byte
		Pop		temp4
		Pop		temp3
		Pop		temp2
		Pop		temp
	ret

;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

EEP_PWM_val_WR:
; Save Register
		Push	temp
		Push	temp2
		Push	temp3
		Push	temp4
		Push	Low_Byte
		Push	High_Byte
		Push	XL
		Push	XH
		Push	ZL
		Push	ZH


		ldi		Low_Byte, Low (OCR_Ch_01_EEP)			// EEPROM- Pointer Low_Byte| Ab hier wird beschrieben
		ldi		High_Byte, High (OCR_Ch_01_EEP)			// EEPROM- Pointer High_Byte| Ab hier wird beschrieben
		ldi		ZL, Low (OCR_Ch_16_EEP+1)				// Bis hier wird geschrieben
		ldi		ZH, High (OCR_Ch_16_EEP+1)				// Bis hier wird geschrieben
		ldi		XL, Low (0)								// Ab hier wird gelesen (R0)
		ldi		XH, High (0)							// Ab hier wird gelesen (R0)
EEP_PWM_val_WR_loop:
		WDR												// WATCHDOG Reset
		clr		temp3									// 	
		ld		temp, X+ 
EEP_Rewrite_PWM_Data:
		cpi		temp3, 3								// Schreibversuche
		Breq	EEP_PWM_val_WR_ERR						// Schreiben nicht mglich	
		rcall	EEPROM_write
		mov		temp2, temp								// Written Data
		rcall	EEPROM_read
		inc		temp3
		cp		temp, temp2
		Brne	EEP_Rewrite_PWM_Data
		adiw	Low_Byte, 1
		cp		Low_Byte, ZL
		cpc		High_Byte, ZH
		Brne	EEP_PWM_val_WR_loop
;***********************************
; R0- R15 wurden abgespeichert	   *
;***********************************

; Atmel   m8.def 
;.equ	OCR1AL	= 0x2a
;.equ	OCR1AH	= 0x2b
;.equ	OCR1BL	= 0x28
;.equ	OCR1BH	= 0x29
;.equ	ICR1L	= 0x26
;.equ	ICR1H	= 0x27

		ldi		Low_Byte, Low (OCR_Ch_OC1AH_EEP)		// EEPROM- Pointer Low_Byte| Ab hier wird beschrieben
		ldi		High_Byte, High (OCR_Ch_OC1AH_EEP)		// EEPROM- Pointer High_Byte| Ab hier wird beschrieben
		ldi		ZL, Low (Control_Reg_EEP)				// Bis hier wird geschrieben
		ldi		ZH, High (Control_Reg_EEP)				// Bis hier wird geschrieben
		ldi		XL, Low (OCR_Ch_OC1AH_SRAM)								// Bis hier wird geschrieben
		ldi		XH, High (OCR_Ch_OC1AH_SRAM)							// Bis hier wird geschrieben
EEP_PWM_val_WR_loop2:
		WDR												// WATCHDOG Reset
		clr		temp3									// 	
		ld		temp, X+ 
EEP_Rewrite_PWM_Data2:
		cpi		temp3, 3								// Schreibversuche
		Breq	EEP_PWM_val_WR_ERR						// Schreiben nicht mglich	
		rcall	EEPROM_write
		mov		temp2, temp								// Written Data
		rcall	EEPROM_read
		inc		temp3
		cp		temp, temp2
		Brne	EEP_Rewrite_PWM_Data2
		adiw	Low_Byte, 1
		cp		Low_Byte, ZL
		cpc		High_Byte, ZH
		Brne	EEP_PWM_val_WR_loop2


; Recover Register
		Pop		ZH
		Pop		ZL
		Pop		XH
		Pop		XL
		Pop		High_Byte
		Pop		Low_Byte
		Pop		temp4
		Pop		temp3
		Pop		temp2
		Pop		temp
 	ret

EEP_PWM_val_WR_ERR:

; Recover Register
		Pop		ZH
		Pop		ZL
		Pop		XH
		Pop		XL
		Pop		High_Byte
		Pop		Low_Byte
		Pop		temp4
		Pop		temp3
		Pop		temp2
		Pop		temp
	ret


;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
; Die auskommentierten Codezeilen dienten als 
Power_UP_HW_Settings_load:		

; Control Register wert laden
		ldi		XL, Low (Control_Reg_SRAM)				// X- Pointer Initialisieren
		ldi		XH, High (Control_Reg_SRAM)				// X- Pointer Initialisieren
		ldi		Low_Byte, Low (Control_Reg_EEP)
		ldi		High_Byte, High (Control_Reg_EEP)
		rcall	EEPROM_read								// Control_Reg_EEP
		ST		X+, temp							
; PWM_CNTR_ADDR_EEP
		adiw	Low_Byte, 1
		rcall	EEPROM_read	
		andi	temp, (1<<TWA6|1<<TWA5|1<<TWA4|1<<TWA3|1<<TWA2|1<<TWA1|1<<TWA0|0<<TWGCE)							
		ST		X+, temp							
		out		TWAR, temp								//
; Clock Select Software PWM. TCCR2 CS
		adiw	Low_Byte, 1								// 	 
		rcall	EEPROM_read								// Clock Select Software PWM
		andi	temp, (0<<WGM20)|(0<<COM21)|(0<<WGM21)|(0<<COM20)|(1<<CS22)|(1<<CS21)|(1<<CS20)
		ST		X+, temp
		in		temp2, TCCR2
		andi	temp2, (1<<WGM20)|(1<<COM21)|(1<<WGM21)|(1<<COM20)|(0<<CS22)|(0<<CS21)|(0<<CS20)
		or		temp, temp2
		out		TCCR2, temp
; Timer Counter1 , TCCR1B
		adiw	Low_Byte, 1								// Clock Select for 16-Bit HW PWM
		rcall	EEPROM_read	
		andi	temp,  (0<<ICNC1)|(0<<ICES1)|(1<<WGM13)|(1<<WGM12)|(1<<CS12)|(1<<CS11)|(1<<CS10)  //CS-> .max 5
		ST		X+, temp
		in		temp2, TCCR1B
		andi	temp2, (1<<ICNC1)|(1<<ICES1)|(1<<WGM13)|(1<<WGM12)|(0<<CS12)|(0<<CS11)|(0<<CS10)  //CS-> .max 5
		or		temp, temp2
		out		TCCR1B, temp
; Timer Counter1 ICR Value load 						// 
		adiw	Low_Byte, 1								// 	Resolution for 16- Bit Channels High_Byte
		rcall	EEPROM_read								//  
		ST		X+, temp 								//
		mov		temp2, temp								// temp2 = kopie von High_Byte
		adiw	Low_Byte, 1								// Resolution for 16- Bit Channels Low_Byte 	 
		rcall	EEPROM_read								// 
		ST		X+, temp 								//
		out		ICR1H, temp2							// 
		out		ICR1L, temp								//
; Software PWM- Resolution
		adiw	Low_Byte, 1
		rcall	EEPROM_read
		ST		X+, temp
		mov		PWM_Cnt_Top, temp
; PWM Speed vs. Programm Berechnungen					// Bestimmt mit unter die Softw. PWM- Geschwindigkeit 
		adiw	Low_Byte, 1								// PWM Speed vs. Programm Berechnungen. Interruptzeit.
		rcall	EEPROM_read								// TimerCounter2 OCR2- Wert	
		ST		X+, temp	
		out		OCR2, temp
	ret

;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

Power_UP_PWM_Values_load:
; PWM- Werte(OCR) laden und in die zugehrigen Register kopieren
		ldi		Low_Byte, Low (OCR_Ch_01_EEP)
		ldi		High_Byte, High (OCR_Ch_01_EEP)
		ldi		YL, Low (OCR_CH_01_SRAM)					//
		ldi		YH, High (OCR_CH_01_SRAM)					// SRAM- Kopie
		ldi		XL, Low (0)									// X- Pointer Initialisieren R0= I/O=0
		ldi		XH, High (0)								// X- Pointer Initialisieren R0= I/O=0
		ldi		ZL, Low (OCR_Ch_OC1AH_EEP)					// Referenzwert zum vergleichen
		ldi		ZH, High (OCR_Ch_OC1AH_EEP)			    	// Referenzwert zum vergleichen
Power_UP_PWM_Values_load_loop:								// 	Werte fr Soft. PWM auslesen und ins SRAM kopieren.
		rcall	EEPROM_read
		ST		X+, temp
		ST		Y+, temp
		adiw	Low_Byte, 1
		cp		Low_Byte, ZL
		cpc		High_Byte, ZH
		Brne	Power_UP_PWM_Values_load_loop
; Software PWM Values CH1- CH 16 are loaded into R0- R16

		ldi		XL, Low (OCR_Ch_OC1AH_SRAM)									// X- Pointer Initialisieren OCR_Ch_OC1AH_SRAM
		ldi		XH, High (OCR_Ch_OC1AH_SRAM)								// X- Pointer Initialisieren OCR_Ch_OC1AH_SRAM
; Timer Counter 1 OCR1A Value load
		rcall	EEPROM_read								// OCR1AH- Lesen
		ST		X+, temp
		mov		temp2, temp								// OCR1AH- im temp2 sichern
		adiw	Low_Byte, 1								// Kanal OC1A-  Low_Byte
		rcall	EEPROM_read
		ST		X+, temp								// OCR1A Store Low_Byte
		out		OCR1AH, temp2							// Zuerst High_Byte
		out		OCR1AL, temp 
; Timer Counter1 OCR1B Value load
		adiw	Low_Byte, 1								// Kanal OC1B- High_Byte
		rcall	EEPROM_read
		ST		X+, temp
		mov		temp2, temp								// OCR1BH- im temp2 sichern
		adiw	Low_Byte, 1								// Kanal OC1B- Low_Byte
		rcall	EEPROM_read
		ST		X+, temp
		out		OCR1BH, temp2
		out		OCR1BL, temp		
	ret

;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
PWM_Default_val_load:
; Register mit Default Wert laden
		ser		temp
		mov		OCR_Ch_1, temp
		sts		OCR_CH_01_SRAM, temp
		mov		OCR_Ch_2, temp
		sts		OCR_CH_02_SRAM, temp
		mov		OCR_Ch_3, temp
		sts		OCR_CH_03_SRAM, temp
		mov		OCR_Ch_4, temp
		sts		OCR_CH_04_SRAM, temp
		mov		OCR_Ch_5, temp
		sts		OCR_CH_05_SRAM, temp
		mov		OCR_Ch_6, temp
		sts		OCR_CH_06_SRAM, temp
		mov		OCR_Ch_7, temp
		sts		OCR_CH_07_SRAM, temp
		mov		OCR_Ch_8, temp
		sts		OCR_CH_08_SRAM, temp
		mov		OCR_Ch_9, temp
		sts		OCR_CH_09_SRAM, temp
		mov		OCR_Ch_10, temp
		sts		OCR_CH_10_SRAM, temp
		mov		OCR_Ch_11, temp
		sts		OCR_CH_11_SRAM, temp
		mov		OCR_Ch_12, temp
		sts		OCR_CH_12_SRAM, temp
		mov		OCR_Ch_13, temp
		sts		OCR_CH_13_SRAM, temp
		mov		OCR_Ch_14, temp
		sts		OCR_CH_14_SRAM, temp
		mov		OCR_Ch_15, temp
		sts		OCR_CH_15_SRAM, temp
		mov		OCR_Ch_16, temp
		sts		OCR_CH_16_SRAM, temp
	
		out		OCR1AH, temp
		out		OCR1AL, temp
	
		out		OCR1BH, temp
		out		OCR1BL, temp


	 	clr		temp2

		sts		OCR_Ch_OC1AH_SRAM, temp2		
		sts		OCR_Ch_OC1AL_SRAM, temp2

		sts		OCR_Ch_OC1BH_SRAM, temp2
		sts		OCR_Ch_OC1BL_SRAM, temp2


	ret

;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX		

EEP_Byte_Save:
; Description: Mit dieser Routine wird ein Byte im EEPROM gespeichert.
; Sollte ein Fehler beim schreiben auftreten so wird erneut versucht, 
; und das bis zu 3xMal danach wird aufgegeben.
; Input: EEPROM Adresse Low, High_Byte
; Input: temp = zu schreibende Daten
; Parameter bergabe Beispiel:
;		ldi		temp, 0x13				// Zu schreibende Daten
;		ldi		Low_Byte, Low ()		// EEPROM- Pointer Low_Byte| 
;		ldi		High_Byte, High ()		// EEPROM- Pointer High_Byte| 

		push	temp					// Register Sichern
		push	temp2
		push	temp3					
		Push	Low_Byte
		Push	High_Byte				// Register Sichern ende

		clr		temp3					// Schreibversuchs- Zhler lschen
EEP_B_Save_ReWR:
		cpi		temp3, 3				// Schreibversuche
		Breq	EEP_B_WR_ERR			// Schreiben nicht mglich	
		rcall	EEPROM_write
		mov		temp2, temp				// Zu schreibende Daten absichern
		rcall	EEPROM_read				// Geschriebebe Daten auslesen
		inc		temp3					// Schreibversuchszhler erhhen (+1)
		cp		temp, temp2				// berprfe ob die geschriebene und ausgelesene Daten bereinstimmen
		Brne	EEP_B_Save_ReWR

		Pop		High_Byte				// Register wiederherstellen
		Pop		Low_Byte
		Pop		temp3				
		Pop		temp2
		Pop		temp
	ret

EEP_B_WR_ERR:							//  Save versuch gescheitert
; Irgendwelche Flags Setzen als Schreibfehler
		Pop		High_Byte
		Pop		Low_Byte
		Pop		temp3					// Register wiederherstellen
		Pop		temp2
		Pop		temp
	ret

;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
EEP_Byte_S_RD:
; Description: Mit dieser Routine wird ein Byte aus den EEPROM gelesen.
; Sollte ein Fehler beim lesen auftreten so wird erneut versucht, 
; und das bis zu 3xMal hintereinander. Stimmen die 3 Bytes nicht berein so wird ein Error Flag gesetzt
; Input: EEPROM Adresse Low, High_Byte
; Output: temp = ausgelesene Daten
; Parameter bergabe Beispiel:
;		ldi		Low_Byte, Low ()		// EEPROM- Pointer Low_Byte| 
;		ldi		High_Byte, High ()		// EEPROM- Pointer High_Byte| 

		push	temp					// Register Sichern
		push	temp2
		push	temp3					

EEP_BS_ReRD:
		rcall	EEPROM_Read
		mov		temp2, temp				// Ausgelesenes Byte sichern
		rcall	EEPROM_Read				// 
		mov		temp3, temp				// Ausgelesenes Byte sichern
		rcall	EEPROM_Read				// 
		cp		temp, temp2				// 
		Brne	EEP_BS_ReRD
		cp		temp, temp3				// 
		Brne	EEP_BS_ReRD
		cp		temp2, temp3
		Brne	EEP_BS_ReRD

		Pop		temp3				
		Pop		temp2
		Pop		temp
	ret

EEP_BS_RD_ERR:							// 
; Irgendwelche Flags Setzen als Schreibfehler

		Pop		temp3					// Register wiederherstellen
		Pop		temp2
		Pop		temp
	ret


;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
EEPROM_read:	
; Wait for completion of previous write
		sbic 	EECR, EEWE
		rjmp 	EEPROM_read
; Set up address (High_Byte : Low_Byte) in address register
		out 	EEARH, High_Byte
		out 	EEARL, Low_Byte
; Start eeprom read by writing EERE
		sbi 	EECR, EERE
; Read data from data register
		in 		temp, EEDR
	ret

EEPROM_write:
; Wait for completion of previous write
		sbic 	EECR, EEWE
		rjmp 	EEPROM_write
; Set up address (High_Byte : Low_Byte) in address register
		out 	EEARH, High_Byte
		out 	EEARL, Low_Byte
; Write data (temp) to data register
		out 	EEDR,temp
; Write logical one to EEMWE
		sbi 	EECR, EEMWE
; Start eeprom write by setting EEWE
		sbi 	EECR, EEWE	
	ret












