




; Aufruf+ reti sind mit eingerechnet
; 80x Clocks +4xPWM Kanle = 114 Clocks
; 51x Clocks bei PWM_Counter = PWM_Cnt_Top	 +4xPWM Kanle = 60 Clocks

TIM2_COMP:			// Timer Counter2 Compare Match IRQ Routine

		Push	temp						// Push temp, SREG and temp2 on to Stack
		in		temp, SREG					//
		Push	temp						//	SREG- sichern
		Push	temp2						//
       	Push	temp3	
		Push	Low_Byte
		Push	High_Byte

PWM_timer_main:	
		inc		PWM_Counter
		cpse	PWM_Counter, PWM_Cnt_Top
		rjmp	PWM_CALC_main		
		rjmp 	Cnt_equal_Top		
		
			
PWM_CALC_main:

		clr		temp
		clr		temp2
		clr		temp3

PWM_CH_1:	
		cp		PWM_Counter,OCR_Ch_1 		 
		brlo	PWM_CH_2					 
		ori		temp, 1						// Port Pin 0			 

PWM_CH_2:
		cp		PWM_Counter, OCR_Ch_2
		brlo	PWM_CH_3
		ori		temp, 2						// Port Pin 1

PWM_CH_3:
		cp		PWM_Counter, OCR_Ch_3
		brlo	PWM_CH_4
		ori		temp, 4						// Port Pin 2

PWM_CH_4:
		cp		PWM_Counter, OCR_Ch_4
		brlo	PWM_CH_5
		ori		temp, 8						// Port Pin 3

PWM_CH_5:
		cp		PWM_Counter, OCR_Ch_5
		brlo	PWM_CH_6
		ori		temp, 16					// Port Pin $

PWM_CH_6:
		cp		PWM_Counter, OCR_Ch_6
		brlo	PWM_CH_7
		ori		temp, 32

PWM_CH_7:
		cp		PWM_Counter, OCR_Ch_7
		brlo	PWM_CH_8
		ori		temp, 64

PWM_CH_8:
		cp		PWM_Counter, OCR_Ch_8
		brlo	PWM_CH_9
		ori		temp, 128

// PWM_Ch1-8 (PortD) updated

PWM_CH_9:
		cp		PWM_Counter, OCR_Ch_9
		brlo	PWM_CH_10
		ori		temp2, 1					// Port Pin 0

PWM_CH_10:
		cp		PWM_Counter, OCR_Ch_10
		brlo	PWM_CH_11
		ori		temp2, 2					// Port Pin 1

PWM_CH_11:
		cp		PWM_Counter, OCR_Ch_11
		brlo	PWM_CH_12
		ori		temp2, 4					// Port Pin 2

PWM_CH_12:
		cp		PWM_Counter, OCR_Ch_12		// Existiert nicht wegen OC0 (PortB3)
		brlo	PWM_CH_13
		ori		temp2, 8
// PWM_Ch9-12 (PortC) updated
PWM_CH_13:
		cp		PWM_Counter, OCR_Ch_13
		brlo	PWM_CH_14
		ori		temp3, 1					// Port Pin 5

PWM_CH_14:
		cp		PWM_Counter, OCR_Ch_14
		brlo	PWM_CH_15
		ori		temp3, 8					// Port Pin 6

PWM_CH_15:
		cp		PWM_Counter, OCR_Ch_15
		brlo	PWM_CH_16	
		ori		temp3, 16					// Port Pin 7
// PWM_Ch9-15 (PortB) updated
PWM_CH_16:
		cp		PWM_Counter, OCR_Ch_16
		brlo	leave_PWM_ocr				//
		ori		temp3, 32					// Port Pin 7




leave_PWM_ocr:
		out		PortD, temp					// 
; Isoliere Ausgabe PortC fr PWM- Kanle 10-12
		in		temp, PortC 					// Der Wert von temp ist ab hier nicht mehr von bedeutung.
		andi	temp, 0b11_11_0000			// SDA, SCL, 
		or		temp2, temp
		out		PortC, temp2

; Isoliere Ausgabe PortB fr PWM- Kanle 10-12							// PortD, untere Porthlfte = PWM
		in		temp, PortB
		andi	temp, 0b11_000110			// Alle verwendete Kanle lschen, bis auf 16- Bit HW PWM
		or		temp3, temp
		out		PortB, temp3

; Restore_Register
		Pop		High_Byte
		Pop		Low_Byte
		Pop		temp3
		Pop		temp2						// Pop from Stack Temp2, SREG,  temp
		Pop		temp						//
		out		SREG, temp					//
		Pop		temp						//	
	reti

; Noch 8- Befehle reserve bevor kein platzt mehr da ist

											// Exit CTC IRQ and 
Cnt_equal_Top:
; Update Register = 32 additional Clocks

		
		sbrs	SREG_3, UPDA30				// Updateflag fr hardware PWM Outputs
		rjmp	UPD_req_OCR1B

		lds		temp, OCR_Ch_OC1AL_SRAM
		lds		temp2, OCR_Ch_OC1AH_SRAM
		out		OCR1AH, temp2
		out		OCR1AL, temp
		cbr		SREG_3, 1<<UPDA30			// UPDA30= OCR1A- Write Enable

UPD_req_OCR1B:
		sbrs	SREG_3, UPDA31				// Updateflag fr hardware PWM Outputs
		rjmp	UPD_req_IRC1

		lds		temp, OCR_Ch_OC1BL_SRAM
		lds		temp2, OCR_Ch_OC1BH_SRAM
		out		OCR1BH, temp2
		out		OCR1BL, temp
		cbr		SREG_3, 1<<UPDA31			// UPDA31= OCR1B- Write Enable

UPD_req_IRC1:
		sbrs	SREG_3, UPDA32				// Updateflag fr IRC Register
		rjmp	Cnt_equal_Top_2
		lds		temp, Res_HW_PWM_LB_SRAM 
		lds		temp2, Res_HW_PWM_HB_SRAM
		out		ICR1H, temp2
		out		ICR1L, temp
		cbr		SREG_3, 1<<UPDA32			// UPDA32= ICR1- Write Enable

Cnt_equal_Top_2:
		clr		PWM_Counter			    	// Clear PWM_Count

; Restore_Register
		Pop		High_Byte
		Pop		Low_Byte
		Pop		temp3
		Pop		temp2						// Pop from Stack Temp2, SREG,  temp
		Pop		temp						//
		out		SREG, temp					//
		Pop		temp	
	reti
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
